/***********************************************************************
*           See Accompanying licence file QSAS_licence                 *
***********************************************************************/

#include "DvObj.h"
#include "qplug_if.h"

extern "C" QplugReturnStatus DvQarCHSIGN(vector<DvObject_var>&, vector<DvObject_var>&);

QplugReturnStatus DvQarCHSIGN(vector<DvObject_var>& inputs, vector<DvObject_var>& outputs)
{
	QplugReturnStatus	status;
	int qar_status;

	DvObject_var in_ptr;
	DvObject_var out_ptr;

	DvString out_name;

	status = QPLUG_SUCCESS;


	//	Unpack the input data objects

	in_ptr = inputs[0];

	// Get name of output object

 	out_name = GetSlotText(0);
 	if (out_name.empty()) {
    	out_name = "ChSignObj";
    	SetSlotText(0, out_name.c_str());
	}

	// do arithmetic...

	out_ptr = in_ptr->chgSign();

	if (out_ptr.is_nil()) {
    	QplugAppendTextDisplay ("Arithmetic>> This Operation is not yet supported for this input type\n");
    	return QPLUG_FAILURE; 
	}

	if (out_ptr->nError() > 0) QplugAppendTextDisplay( out_ptr->getError().c_str() );

  	outputs.push_back(out_ptr);

  	QplugAppendTextDisplay ("Change sign: Done\n");
  
	return status;

}

