/***********************************************************************
*           See Accompanying licence file QSAS_licence                 *
***********************************************************************/

#include "DvObj.h"
#include "qplug_if.h"

extern "C" QplugReturnStatus DvQarPOWER(vector <DvObject_var>&, vector <DvObject_var>&);

QplugReturnStatus DvQarPOWER(vector <DvObject_var>& inputs, vector <DvObject_var>& outputs)
{
	QplugReturnStatus	status;

	DvObject_var in1_ptr;
	DvObject_var in2_ptr;
	DvObject_var out_ptr;

	DvString out_name;

	status = QPLUG_SUCCESS;


	//	Unpack the input data objects

	in1_ptr = inputs[0];
	in2_ptr = inputs[1];

	if(in2_ptr->arraySize() > 1)
	{
		QplugAppendTextDisplay("cannot raise to power of vector or array");
		return QPLUG_FAILURE;
	}
	if(in2_ptr->seqSize() > 1)
	{
		QplugAppendTextDisplay("cannot raise to power of sequence");
		return QPLUG_FAILURE;
	}

	// Get name of output object

 	out_name = GetSlotText(0);
 	if ( out_name.empty() ) {
    	out_name = "Sum";
    	SetSlotText(0, out_name.c_str());
 	}


	// do arithmetic...

	if(in2_ptr->is_dbl()) out_ptr = in1_ptr->power( in2_ptr->dbl(0) );
	else if(in2_ptr->is_int()) out_ptr = in1_ptr->power( in2_ptr->itg(0) );


	if ( out_ptr.is_nil() ) {
    	QplugAppendTextDisplay ("Arithmetic>> Power not yet supported between these types\n");
    	return QPLUG_FAILURE; 
	}
 
	if (out_ptr->nError() > 0) QplugAppendTextDisplay( out_ptr->getError().c_str() );


	//	..add  the output series to the list

	outputs.push_back(out_ptr);

	QplugAppendTextDisplay ("Power: Done\n");
  
	return status;

}

