#include "qcalcEvaluator.h"


void QEvaluatorDotProd::evaluate(QVector<VInSlot*>& in, QVector<VOutSlot*>& out, bool& ok, QString& message)
{
    ok=true;
    DvObject_var result;
    
    QEvaluator::evaluate(in, out, ok, message);
    if(!ok)
        return;
    
    DvObject_var val1=in[0]->connectedSlot()->getValue(ok);
    if(!ok)
    {
        message=QString("Input ")+in[0]->getName()+QString(" invalid");
        ok=false;
        return;
    }
    DvObject_var val2=in[1]->connectedSlot()->getValue(ok);
    if(!ok)
    {
        message=QString("Input ")+in[1]->getName()+QString(" invalid");
        ok=false;
        return;
    }
    
    // do arithmetic...
    
    result = val1->dot(val2);
    
    if ( result.is_nil() )
    {
        message=QString("Operation Not valid for these input types" );
        ok=false;
        return;
    }
    
    
    out[0]->setValue(result, true);
}

void QEvaluatorNormalize::evaluate(QVector<VInSlot*>& in, QVector<VOutSlot*>& out, bool& ok, QString& message)
{
    ok=true;
    DvObject_var result;
    
    QEvaluator::evaluate(in, out, ok, message);
    if(!ok)
        return;
    
    DvObject_var val1=in[0]->connectedSlot()->getValue(ok);
    if(!ok)
    {
        message=QString("Input ")+in[0]->getName()+QString(" invalid");
        ok=false;
        return;
    }
    
    
    // do arithmetic...
    
    result = val1->normalize();
    
    if ( result.is_nil() )
    {
        message=QString("Operation Not valid for these input types" );
        ok=false;
        return;
    }
    
    
    out[0]->setValue(result, true);
}
