#include "qcalcEvaluator.h"


void QEvaluatorSqrt::evaluate(QVector<VInSlot*>& in, QVector<VOutSlot*>& out, bool& ok, QString& message)
{
	ok=true;
	DvObject_var result;
	
	QEvaluator::evaluate(in, out, ok, message);
	if(!ok)
		return;
	
	DvObject_var val1=in[0]->connectedSlot()->getValue(ok);
	if(!ok)
	{
		message=QString("Input ")+in[0]->getName()+QString(" invalid");
		ok=false;
		return;
	}
	
	if(val1->isThreeVector())
	{
		message=QString("Operation is not valid for vector objects");
		ok=false;
		return;
	}
	
	// do arithmetic...

	result = val1->sqrt();


	if (result.is_nil())
	{
		message=QString("Arithmetic>> sqrt is not yet supported for the input type" );
		ok=false;
		return;
	}

	out[0]->setValue(result, true);
}

