#include "qcalcEvaluator.h"


void QEvaluatorSubtract::evaluate(QVector<VInSlot*>& in, QVector<VOutSlot*>& out, bool& ok, QString& message)
{
	ok=true;
	DvObject_var result;
	
	QEvaluator::evaluate(in, out, ok, message);
	if(!ok)
		return;
	
	DvObject_var val1=in[0]->connectedSlot()->getValue(ok);
	if(!ok)
	{
		message=QString("Input ")+in[0]->getName()+QString(" invalid");
		ok=false;
		return;
	}
	DvObject_var val2=in[1]->connectedSlot()->getValue(ok);
	if(!ok)
	{
		message=QString("Input ")+in[1]->getName()+QString(" invalid");
		ok=false;
		return;
	}
	
	// xrefs and dims are taken from first object...
	if(val1->seqSize() > 1){
		result = val1 - val2;
	}
	else{
		// val2 may be a sequence
		result = val2->chgSign();
		result += val1;
	}

		
	if(result.is_nil())
	{
		message="Operation Subtract is not yet supported between these input types";
		ok=false;
		return;
	}
	
	out[0]->setValue(result, true);
}

