
/***********************************************************************
*           See Accompanying licence file QSAS_licence                 *
***********************************************************************/

#include "qplug_if.h"
#include "DvObj.h"

extern "C" QplugReturnStatus DvToBaseSI(vector<DvObject_var>&, vector<DvObject_var>&);

QplugReturnStatus DvToBaseSI(vector<DvObject_var>& inputs, vector<DvObject_var>& outputs)
{

	DvObject_var in_ptr;
	DvObject_var out_ptr;

	DvString attr_ptr;
	DvString out_name;

 	if(inputs.size() < 1) {
    	QplugAppendTextDisplay ("no inputs\n");
    	return QPLUG_FAILURE; 
 	} 
 
	//	Unpack the input data objects

	in_ptr = inputs[0];

	if(in_ptr.is_nil() ){
    	QplugAppendTextDisplay ( "Invalid input object \n");
    	return QPLUG_FAILURE; 
	}
 

	// Get name of output object

 	out_name = GetSlotText(0);
 	if (out_name.empty()) {
    	out_name = "ObjectInSI";
    	SetSlotText(0, out_name.c_str());
	}


	// create output object

  	attr_ptr = in_ptr->getXrefText(SI_CONVERSION);
  	if( !attr_ptr.empty() ){
		DvString newAttr = "1 >";
		newAttr += attr_ptr.after(">");
		out_ptr = in_ptr->changeUnitsTo(newAttr, attr_ptr.after(">"));
	}
	else{
    	QplugAppendTextDisplay ( "No SI conversion metadata available for input object \n");
    	return QPLUG_FAILURE; 
	}

	if (out_ptr->nError() > 0) QplugAppendTextDisplay( out_ptr->getError().c_str() );

	outputs.push_back(out_ptr);

	QplugAppendTextDisplay ("Convert to Base SI - Done.\n");
  
	return QPLUG_SUCCESS;

}

