
#ifndef DWT_SET_PLOT_H
#define DWT_SET_PLOT_H

#include "qplug_if.h"
#include "DvObj.h"
#include "PGSpectro.h"
#include "qprofile.h"


extern "C" {
}

//C++ prototypes


QplugReturnStatus ReadFilter(const char* filtname, DvObject_var &gf);

QplugReturnStatus  Run_Dwt(DvObject_var ts_in, int jsize, 
			DvObject_var hf, DvObject_var gf, DvObject_var &wavlcoef);
			
QplugReturnStatus  Run_MoDwt(DvObject_var ts_in, int jsize,  
			DvObject_var hf, DvObject_var gf, DvObject_var &wavlcoef);
			
QplugReturnStatus SPectro_set(DvObject_var wav_mat, DvObject_var ttag,
		int level, PGSpectro *spectrop, DvObject_var gfilt_var, 
		Yes_or_No dwt_yes_no, const char *x_lab, const char *y_lab, const char *w_lab);
				
QplugReturnStatus SPectro_fill(int nx, int Llen, DvObject_var eg, 
		DvObject_var wav_seq, PGSpectro *spectrop,
		Yes_or_No dwt_yes_no, DvObject_var z);
					
Yes_or_No isPowerOf2(long m);
			
	
void clean_all(PGSpectro *spectrop/*, PGXYtrace *tracep*/);	
				
#endif
			
									
