#ifndef INTERVAL_DIALOG_H
#define INTERVAL_DIALOG_H

#include "qt_version.h"

#include <QMainWindow>
#include <QPushButton>
#include <QMessageBox>
#include "IntervalWidgets.h"

class PlotWindow;
class FrameItem;
// #include "IntervalSlider.h"

class IntervalDialog : public QMainWindow
{
	Q_OBJECT

	public:
		
		IntervalDialog(PlotWindow* parent);
		
		void setAsTimeInterval(DvTime tmin, DvTime tmax/*, double currentTmin, double currentTmax*/, FrameItem* frame=NULL);
		
		void setAsXInterval(double tmin, double tmax);
		
		void setViewRange(DvEvent range);
		
		void setViewRange(double min, double max);
		
		void setAvailabilityRange(double min, double max);
		
		
	signals:
		
		void rescaleScalar(double tmin, double tmax);
		void rescaleTime(DvEvent);
		
	public slots:
		
		void apply();
		
		void dismiss();
		
		void add();
		void capture();
		
	protected:
		
		ScalarIntervalWidget* xWidget;
		TimeIntervalWidget* timeWidget;
		QPushButton * captureButton;
		QPushButton * addButton;
		bool isTimeInterval;
		FrameItem* frame;
		QPushButton * applyButton;
		
	protected slots:
		
		void closeEvent(QCloseEvent * e)
		{
			setVisible(false);
		}
};

#endif
